/*
// Copyright (c) 2018 Intel Corporation
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
*/

#include "auto_tuner.h"
#include "auto_tuner_offline.h"
namespace kernel_selector 
{
    // SKL GT4e
    void tuning_cache_193B_B8(tuning_data& td)
    {
        td.td.insert({
            { "11207257238719531888", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 325) },
           /* { "12348135936862667024", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 202) },
            { "1540041682425757361", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 320) },
            { "6949539207944972855", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "4197617702037834389", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 326) },
            { "13898284586432291433", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "3715177305271762194", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 205) },
            { "481328129206881674", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 325) },
            { "10001963042016663554", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 325) },
            { "15471470494305051299", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 323) },
            { "14716719350966652036", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 333) },
            { "13404888565084206853", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 200) },
            { "1249137685908951501", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 320) },
            { "4840004190985490064", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "5120466856097219243", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "4701832665603867798", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 243) },
            { "6181272224000872375", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 325) },
            { "2030309697153345387", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 335) },
            { "11207257238719531888", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 325) },
            { "12348135936862667024", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 202) },
            { "1540041682425757361", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 320) },
            { "6949539207944972855", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "4197617702037834389", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 326) },
            { "13898284586432291433", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "3715177305271762194", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 205) },
            { "481328129206881674", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 325) },
            { "10001963042016663554", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 325) },
            { "15471470494305051299", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 323) },
            { "14716719350966652036", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 333) },
            { "13404888565084206853", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 200) },
            { "1249137685908951501", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 320) },
            { "4840004190985490064", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "5120466856097219243", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "4701832665603867798", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 243) },
            { "6181272224000872375", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 325) },
            { "2030309697153345387", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 335) },
            { "10728212277329722684", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "877436308867220589", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "18375125668176498051", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "14907097142953816744", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "2525260242689556544", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 375) },
            { "13328449155966085543", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 373) },
            { "11856266545854830143", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "15993427814066246646", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "2100891581797371600", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 275) },
            { "12242618640422208652", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "6133592828563353516", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 304) },
            { "18232278892738147217", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 333) },
            { "11992625045241269569", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 298) },
            { "12601126285773042005", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 297) },
            { "5079055505117153635", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 195) },
            { "7457899998356343871", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 291) },
            { "6343888265369366589", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 296) },
            { "10791067159964399241", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 309) },
            { "11327097771110264965", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 183) },
            { "5245308722062496788", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 314) },
            { "10792503079194374004", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 178) },
            { "4818231379191523896", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 288) },
            { "2198278382394812839", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 258) },
            { "3800011935243649447", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 298) },
            { "9631545863582097486", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 255) },
            { "7777333052643961206", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 251) },
            { "1779941298820543013", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 179) },
            { "3621930417735246405", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 263) },
            { "14435120971846098308", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 188) },
            { "2893564501191050837", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 181) },
            { "8108843303778211282", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 256) },
            { "3682813162987778705", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 257) },
            { "15494543914974994991", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 179) },
            { "7565221050911842393", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 93) },
            { "5629670679897666607", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 257) },
            { "11754316727756881612", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 96) },
            { "10990741293315393791", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 208) },
            { "17024388383581997032", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 208) },
            { "10302338806536775954", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 204) },
            { "7915318733663535312", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 205) },
            { "13702692566238948173", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 208) },
            { "2909728331855309274", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 207) },
            { "13071545223094862275", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 206) },
            { "9631481972809246378", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 211) },
            { "13540002981450186147", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 203) },
            { "7076937538747704750", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 203) },
            { "10290107543739998181", std::make_tuple("fully_connected_gpu_bf_io_input_spatial", -1) },
            { "6767245864232675168", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "9287404618748313247", std::make_tuple("convolution_gpu_bfyx_gemm_like", -1) },
            { "8728178019712933221", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 294) },
            { "18251360413872841969", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 295) },
            { "18271689282126907793", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 294) },
            { "954796765467489259", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 325) },
            { "13597240991532942069", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 178) },
            { "4135003545872878882", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 296) },
            { "11883485911218628865", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 293) },
            { "2242915551775617989", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 291) },
            { "10556089809203693400", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 290) },
            { "3727142736386026852", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 333) },
            { "1622880009460832832", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 182) },
            { "4437258459981739942", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 296) },
            { "14691372262153587653", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 295) },
            { "12181607120522804433", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 334) },
            { "3159681096461848644", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 295) },
            { "6729785110495533200", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 295) },
            { "15322019609805777935", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 183) },
            { "7024495439434892956", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 295) },
            { "10416622008071151225", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 173) },
            { "5796500397424307442", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 249) },
            { "15702382940521972117", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 249) },
            { "6093575518270471235", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 258) },
            { "5805383505505929391", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 258) },
            { "1801731858063091191", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 175) },
            { "1559798212423183813", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 176) },
            { "5594180958505308003", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 249) },
            { "4766071144928072260", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 177) },
            { "8650948093564284852", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 248) },
            { "3883845471211207871", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 248) },
            { "4366168099274266975", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 171) },
            { "578703329577922869", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 253) },
            { "16863960779539003201", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 249) },
            { "15450609897480659306", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 178) },
            { "8203550467004532364", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 257) },
            { "7431849514656037251", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 257) },
            { "14484890926084856480", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 179) },
            { "4424217045094988504", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 249) },
            { "7994179151788368291", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 180) },
            { "15192024816519005250", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 258) },
            { "4747159205186229582", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 103) },
            { "5485971317082563152", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 249) },
            { "18128162750557822655", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 91) },
            { "12421707187947291166", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 208) },
            { "792684262493086891", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 208) },
            { "941626985322260281", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 207) },
            { "11868551452004726281", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 200) },
            { "14352303529756685990", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 206) },
            { "10702234389482091891", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 208) },
            { "3895088069642140043", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 200) },
            { "5334566325056222430", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 205) },
            { "8306337702797456793", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 208) },
            { "15720507574336564201", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 240) },
            { "3277243911383750280", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 208) },
            { "18150429561058646714", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 240) },
            { "11169292427557543138", std::make_tuple("convolution_gpu_bfyx_os_iyx_osv16", 203) },
            { "13933912937625580405", std::make_tuple("fully_connected_gpu_bf_io_input_spatial", -1) },*/
           
            });
    }
}