/*******************************************************************************
* Copyright 2017-2018 Intel Corporation
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*******************************************************************************/

INST_TEST_CASE(ResNet_Blocked_part1,
    PARAMS(nchw, Ohwi8o, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  3,     224,  224,  64,   112,  112,   7,  7,  3,  3,  2,  2),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  64,    56,   56,   256,   56,   56,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  64,    56,   56,   64,    56,   56,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  64,    56,   56,   64,    56,   56,   3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  64,    56,   56,   256,   56,   56,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   56,   56,   64,    56,   56,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  64,    56,   56,   64,    56,   56,   3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  64,    56,   56,   256,   56,   56,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   56,   56,   64,    56,   56,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  64,    56,   56,   64,    56,   56,   3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  64,    56,   56,   256,   56,   56,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   56,   56,   512,   28,   28,   1,  1,  0,  0,  2,  2),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   56,   56,   128,   28,   28,   1,  1,  0,  0,  2,  2),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  128,   28,   28,   128,   28,   28,   3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  128,   28,   28,   512,   28,   28,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  512,   28,   28,   128,   28,   28,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  128,   28,   28,   128,   28,   28,   3,  3,  1,  1,  1,  1)
);

INST_TEST_CASE(ResNet_Blocked_part2,
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  128,   28,   28,   512,   28,   28,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  512,   28,   28,   128,   28,   28,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  128,   28,   28,   128,   28,   28,   3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  128,   28,   28,   512,   28,   28,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  512,   28,   28,   128,   28,   28,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  128,   28,   28,   128,   28,   28,   3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  128,   28,   28,   512,   28,   28,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  512,   28,   28,   1024,  14,   14,   1,  1,  0,  0,  2,  2),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  512,   28,   28,   256,   14,   14,   1,  1,  0,  0,  2,  2),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   14,   14,   256,   14,   14,   3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   14,   14,   1024,  14,   14,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  1024,  14,   14,   256,   14,   14,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   14,   14,   256,   14,   14,   3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   14,   14,   1024,  14,   14,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  1024,  14,   14,   256,   14,   14,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   14,   14,   256,   14,   14,   3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   14,   14,   1024,  14,   14,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  1024,  14,   14,   256,   14,   14,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   14,   14,   256,   14,   14,   3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   14,   14,   1024,  14,   14,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  1024,  14,   14,   256,   14,   14,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   14,   14,   256,   14,   14,   3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   14,   14,   1024,  14,   14,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  1024,  14,   14,   256,   14,   14,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   14,   14,   256,   14,   14,   3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  256,   14,   14,   1024,  14,   14,   1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  1024,  14,   14,   2048,  7,    7,    1,  1,  0,  0,  2,  2),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  1024,  14,   14,   512,   7,    7,    1,  1,  0,  0,  2,  2),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  512,   7,    7,    512,   7,    7,    3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  512,   7,    7,    2048,  7,    7,    1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  2048,  7,    7,    512,   7,    7,    1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  512,   7,    7,    512,   7,    7,    3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  512,   7,    7,    2048,  7,    7,    1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  2048,  7,    7,    512,   7,    7,    1,  1,  0,  0,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  512,   7,    7,    512,   7,    7,    3,  3,  1,  1,  1,  1),
    PARAMS(FMT_DATA_BLOCKED, FMT_WEIGHTS_BLOCKED, FMT_BIAS, FMT_DATA_BLOCKED,
        2,  1,  512,   7,    7,    2048,  7,    7,    1,  1,  0,  0,  1,  1)
);
